# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Commerce::Mgmt::V2015_06_01_preview
  module Models
    #
    # Indicates that a monetary commitment is required for this offer
    #
    class MonetaryCommitment < OfferTermInfo

      include MsRestAzure


      def initialize
        @Name = "Monetary Commitment"
      end

      attr_accessor :Name

      # @return The list of key/value pairs for the tiered meter rates, in the
      # format 'key':'value' where key = price, and value = the corresponding
      # discount percentage. This field is used only by offer terms of type
      # 'Monetary Commitment'.
      attr_accessor :tiered_discount

      # @return An array of meter ids that are excluded from the given offer
      # terms.
      attr_accessor :excluded_meter_ids


      #
      # Mapper for MonetaryCommitment class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'Monetary Commitment',
          type: {
            name: 'Composite',
            class_name: 'MonetaryCommitment',
            model_properties: {
              effective_date: {
                client_side_validation: true,
                required: false,
                serialized_name: 'EffectiveDate',
                type: {
                  name: 'DateTime'
                }
              },
              Name: {
                client_side_validation: true,
                required: true,
                serialized_name: 'Name',
                type: {
                  name: 'String'
                }
              },
              tiered_discount: {
                client_side_validation: true,
                required: false,
                serialized_name: 'TieredDiscount',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'FloatElementType',
                      type: {
                        name: 'Number'
                      }
                  }
                }
              },
              excluded_meter_ids: {
                client_side_validation: true,
                required: false,
                serialized_name: 'ExcludedMeterIds',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'UuidElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
